#version 430 core

in vec3 eyeWS;
in vec3 lightWS;
in vec3 normalWS;
in vec3 lightCol;

out vec3 finalcolor;

uniform vec3 col;

void main()
{

	vec3 color = (col + lightCol) * 0.5;
	vec3 ambient = color * 0.3;
	vec3 specColor = vec3(0.5, 0.5, 0.5);

	////////////////////////////////////
	// Basic Lighting
	////////////////////////////////////
    vec3 N = normalize(normalWS);
	vec3 L = normalize(lightWS);
    float cosTheta = clamp( dot(N,L), 0, 1);
	float df = 0.8f * cosTheta;

	////////////////////////////////////
	// Specular Highlights
	////////////////////////////////////
	float intensity = max(dot(N, L), 0.0f);
    vec3 spec = vec3(0.3, 0.3, 0.3);
	vec3 eye = normalize(eyeWS);

    if(intensity > 0.0) {
		vec3 h = normalize(L + eye);
		float intSpec = max(dot(h, N), 0.0);
		vec3 spec = specColor * intSpec; 
	}
    vec3 R = reflect(-L, N);
    float cosAlpha = clamp(dot(eye, R), 0, 1);
	specColor = specColor * spec * pow(cosAlpha, 5);

    color = ambient + df * color + specColor;

    finalcolor = color;
}