#version 430 core

layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 uv;
layout(location = 2) in vec3 normals_modelspace;

out vec3 eyeWS;
out vec3 lightWS;
out vec3 normalWS;
out vec3 lightCol;

uniform mat4 MVP;
uniform vec3 cameraPos;
uniform vec3[10] spotLightPos;
uniform vec3[10] offsets;
uniform vec3[10] LightColor;


void main()
{
	vec3 offset = offsets[gl_InstanceID];
	vec3 posi = vertexPosition_modelspace + offset;
	gl_Position = MVP * vec4(posi, 1);

	eyeWS = (cameraPos - posi);
	lightWS = (spotLightPos[gl_InstanceID] - posi);
	normalWS = normals_modelspace; // can do this if M == identity

	lightCol = LightColor[gl_InstanceID];
}

