#version 430 core

layout(location = 0) out vec2 color;

in vec4 position;

void main(){

	float depth = position.z / position.w;
	depth = depth * 2.0 - 1.0;
	
	float moment1 = depth;
	float moment2 = depth * depth;
	
	// Adjusting moments (this is sort of bias per pixel) using derivative
	
	float dx = dFdx(depth);
	float dy = dFdy(depth);
	moment2 += 0.25*(dx*dx+dy*dy);
	
	color = vec2(moment1, moment2);
}

	
	

	