#version 430 core

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;

out vec4 position;

// ModelViewProjection Matrix, from the light's point of view
uniform mat4 depthMVP;
uniform vec3[100] offsets;

void main()
{
	vec3 offset = offsets[gl_InstanceID];
	gl_Position =  depthMVP * vec4(vertexPosition_modelspace + offset, 1);
	position = gl_Position;
}

