#version 430

layout(vertices = 3) out;

in vec3 vPosition[];
in vec3 vNormal[];
in vec2 vTexCoord[];

out vec3 tcPosition[];
out vec3 tcNormal[];
out vec2 tcTexCoord[];

uniform float innerTessLevel;
uniform float outerTessLevel;

#define ID gl_InvocationID

void main(){

    float inTess  = innerTessLevel;
    float outTess = outerTessLevel;

    tcPosition[ID] = vPosition[ID];
    tcNormal[ID]   = vNormal[ID];
    tcTexCoord[ID] = vTexCoord[ID];
    
    if(ID == 0) {
        gl_TessLevelInner[0] = inTess;
        gl_TessLevelInner[1] = inTess;
        gl_TessLevelOuter[0] = outTess;
        gl_TessLevelOuter[1] = outTess;
        gl_TessLevelOuter[2] = outTess;
        gl_TessLevelOuter[3] = outTess;
    }
}