#version 430 core
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_worldspace;

out vec3 Position_worldspace;
out vec3 Normal_worldspace;
out vec3 LightDirection_worldspace_point;
out vec3 LightDirection_worldspace_directional;
out vec3 EyeDirection_worldspace;
out vec2 UV;
out vec4 ShadowCoord;
out vec4 attenuation;
out vec4 attenuationD;

uniform mat4 MVP;
uniform mat4 M;
uniform mat4 DepthBiasMVP;
uniform vec3 CameraPosition_worldspace;
uniform vec3 LightInvDirection_worldspace;
uniform vec3 LightPosition_worldspace;


void main()
{
	Position_worldspace = (M * vec4(vertexPosition_modelspace.xyz, 1)).xyz;
	gl_Position = MVP * vec4(vertexPosition_modelspace.xyz, 1);
	
	ShadowCoord = DepthBiasMVP * vec4(vertexPosition_modelspace,1);


	Normal_worldspace = (M * vec4(vertexNormal_worldspace, 0)).xyz;
	EyeDirection_worldspace = (CameraPosition_worldspace - ( M * vec4(vertexPosition_modelspace,1)).xyz);

	LightDirection_worldspace_point = ((vec4(LightPosition_worldspace, 1) - (M * vec4(vertexPosition_modelspace,1)))).xyz;
	LightDirection_worldspace_directional = LightInvDirection_worldspace.xyz;

	UV = vertexUV;

	attenuation = vec4(LightDirection_worldspace_point, 0) * 0.4f;
	attenuationD = vec4(0);
}