#version 330 core

layout(location = 0) in vec3 vertex;

out vec2 noise_uv1;
out vec2 noise_uv2;
out vec2 noise_uv3;
out vec2 UV;

uniform mat4 VP;
uniform vec3 scrollSpeed;
uniform vec3 scales;
uniform float frameTime;

uniform vec3 FirePosition;
uniform vec2 FireSize;
uniform vec3 CameraRight;
uniform vec3 CameraUp;

void main()
{

	vec3 vertexPosition = FirePosition
		+ CameraRight * vertex.x * FireSize.x
		+ vec3(0.0f, 1.0f, 0.0f) * vertex.y * FireSize.y;
	

	gl_Position = VP * vec4(vertexPosition, 1.0f);
	
	vec2 tmpUvCoord = (vertex.xy + 1.0f) / 2.0f;
	
	UV = tmpUvCoord;
	
	noise_uv1 = tmpUvCoord * scales.x;
	noise_uv1.y = noise_uv1.y - frameTime * scrollSpeed.x;
	
	noise_uv2 = tmpUvCoord * scales.y;
	noise_uv2.y = noise_uv2.y - frameTime * scrollSpeed.y;
	
	noise_uv3 = tmpUvCoord * scales.z;
	noise_uv3.y = noise_uv3.y - frameTime * scrollSpeed.z;
}