#version 330 core
layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

in vec2 sUV_out[];
in vec3 EyeCS_out[];
in vec3 LightDir_out[];
in vec4 ShadowCoord_out[];

out vec2 sUV;
out vec3 EyeCS;
out vec3 LightCS;
out vec3 tangent;
out vec3 bitangent;
out vec4 ShadowCoord;

void main() 
{
	/******************************************************/
	vec3 dPos1 = (gl_in[1].gl_Position - gl_in[0].gl_Position).xyz;
	vec3 dPos2 = (gl_in[2].gl_Position - gl_in[0].gl_Position).xyz;
	vec2 dUV1 = sUV_out[1] - sUV_out[0];
	vec2 dUV2 = sUV_out[2] - sUV_out[0];
	
	float r = 1.0f/ (dUV1.x * dUV2.y - dUV1.y * dUV2.x);
	vec3 tang = (dPos1 * dUV2.y - dPos2 * dUV1.y) * r;
	vec3 bitang = (dPos2 * dUV1.x - dPos1 * dUV2.x) * r;
	/******************************************************/
	
	int i;
	
	for(i=0; i < gl_in.length(); ++i){
		gl_Position = gl_in[i].gl_Position;
	
		sUV = sUV_out[i];
		EyeCS = EyeCS_out[i];
		LightCS = LightDir_out[i];
		
		ShadowCoord = ShadowCoord_out[i];
		/******************************************************/
		tangent = tang;
		bitangent = bitang;
		/******************************************************/

		EmitVertex();
	}

	EndPrimitive();
}