#version 430 core
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 smallUV;

out vec2 sUV_out;
out vec3 EyeCS_out;
out vec3 LightDir_out;
out vec4 ShadowCoord_out;

uniform mat4 MVP;
uniform mat4 M;
uniform vec3 LightInvDirection_worldspace;
uniform vec3 CameraPosition_worldspace;
uniform mat4 DepthBiasMVP;

uniform float waveTime;
uniform float waveHeight;
uniform float waveWidth;

void main()
{
	vec4 v = vec4(vertexPosition_modelspace, 1.0f);
	v.y = sin(waveWidth * v.x + waveTime) * cos(waveWidth * v.z + waveTime) * waveHeight;
	gl_Position = MVP * v;
    
	ShadowCoord_out = DepthBiasMVP * vec4(vertexPosition_modelspace,1);

	EyeCS_out = (CameraPosition_worldspace - ( M * vec4(vertexPosition_modelspace,1)).xyz);
	LightDir_out = LightInvDirection_worldspace.xyz;

	sUV_out = smallUV;
}